; small AI game demo, compile with fasm.
; Original written by Luks, for nasm.
; c:\fasm game.asm game.com
org 0x100
use16
START:

mov     al,0x13
int     0x10

MAIN:
push    word 0x8000
pop     es
push    cs
pop     ds

mov     cx,0xFFFF
mov     al,0
rep     stosb
mov     si,BALLYI
call    PutLine
mov     bx,[si-6]
mov     dx,[si-4]
cmp     dx,195
jb      CMPY
jmp     NEGY
CMPY:
cmp     dx,1
jg      ADDY
NEGY:
neg     word[si]
ADDY:
add     dx,[si]
dec     si
dec     si
cmp     bx,310
jb      CMPX
jmp     NEGX
CMPX:
cmp     bx,6
jg      ADDX
NEGX:
neg     word[si]
ADDX:
add     bx,[si]
sub     si,8
mov     di,dx
imul    di,320
add     di,bx
mov     cl,4
BALL:
mov     [es:di], dword 0x0f0f0f0f
add     di,320
loop    BALL
mov     [si+4],bx
mov     [si+6],dx

; PADS
mov     bp,si
cmp     [si+9],byte 0
je      PAD2
PAD1:
call    PADCHK
jmp     PADS
PAD2:
add     bp,2
call    PADCHK

PADS:
mov     ax,[si]
mov     di,2
call    DRAWPAD
mov     ax,[si+2]
mov     di,314
call    DRAWPAD
push    es
pop     ds
push    word 0xA000
pop     es
mov     cx,32000
xor     si,si
mov     di,si
rep     movsw
mov     ah,0x11
int     0x16
jz      MAIN
mov     ax,0x0003
int     0x10

DRAWPAD:
imul    ax,320
add     di,ax
mov     cx,16
PAD:
mov     [es:di], dword 0x0f0f0f0f
add     di,320
loop    PAD
ret

PADCHK:
cmp     dx,[bp]
jge     PADDOWN
dec     word [bp]
jmp     ENDCHK
PADDOWN:
sub     dx,12
cmp     dx,[bp]
jbe     ENDCHK
inc     word [bp]
ENDCHK:
ret

PutLine:
mov     al,15
mov     di,158
mov     cl,198
@@:
add     di,319
stosb
loop    @b
xor     di,di
call    Hline
xor     dx,dx
xor     di,di
mov     cl,199
Gridlp3:
stosb
add     di,318
stosb
loop    Gridlp3
call    Hline
ret
               
Hline:
mov     al,15
mov     cx,320
rep     stosb
ret

PAD1Y   dw      100
PAD2Y   dw      100
BALLX   dw      160
BALLY   dw      100
BALLXI  dw      -1
BALLYI  dw      -1